"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.decodeSubquery = exports.mongooseSubqueryPlugin = void 0;
const utils_1 = require("./utils");
Object.defineProperty(exports, "decodeSubquery", { enumerable: true, get: function () { return utils_1.decodeSubquery; } });
const defaultOptions = {
    bindHooks: [
        "count",
        "countDocuments",
        "deleteMany",
        "deleteOne",
        "estimatedDocumentCount",
        "find",
        "findOne",
        "findOneAndDelete",
        "findOneAndRemove",
        "findOneAndReplace",
        "findOneAndUpdate",
        "remove",
        "replaceOne",
        "update",
        "updateOne",
        "updateMany",
    ],
};
function mongooseSubqueryPlugin(schema, options = {}) {
    options = Object.assign({}, defaultOptions, options);
    // @ts-ignore
    schema.query.decodeSubquery = function () {
        return __awaiter(this, void 0, void 0, function* () {
            yield (0, utils_1.decodeSubquery)(this, options);
        });
    };
    function run(next) {
        if (typeof this.decodeSubquery === "function") {
            this.decodeSubquery().then(next);
        }
        else {
            next();
        }
    }
    options.bindHooks.forEach((h) => schema.pre(h, run));
}
exports.mongooseSubqueryPlugin = mongooseSubqueryPlugin;
exports.default = mongooseSubqueryPlugin;
//# sourceMappingURL=index.js.map